/**
 * Helper function to map a value to a string using a mapper function.
 *
 * @param value
 * @param mapper
 */
function mapString(value, mapper) {
    return mapper ? mapper(value) : value;
}
export function toStringLiteral(value, mapper) {
    const strVal = mapString(value, mapper);
    return `"${strVal.replace(/\\/g, '\\\\').replace(/"/g, '\\"')}"`;
}
export function toArgumentList(values, mapper) {
    return values
        .map((el) => mapString(el, mapper))
        .join(', ')
        .trimEnd()
        .replace(/,$/, '');
}
export function toInitializerList(values, mapper) {
    return `{ ${toArgumentList(values, mapper)} }`;
}
