import { SourceBlockBuilder } from './builder.block.js';
import { type ExpressionAction, ExpressionBuilder } from './builder.expr.js';
import { type TypeAction, TypeBuilder } from './builder.types.js';
import type { AnyBuilder, BuilderAction } from './common.js';
import type { SourceWriter } from './source-writer.js';
interface FunctionParameter {
    type: string;
    name: string;
}
export declare class FunctionBuilder implements AnyBuilder {
    private name;
    private returnType;
    private parameters;
    private bodyAction?;
    constructor(name: string, returnTypeBuilder?: TypeBuilder, parameters?: FunctionParameter[]);
    withReturnType(type: TypeBuilder | TypeAction): this;
    addParameter(block: FunctionParameter): this;
    withBody(block: BuilderAction<SourceBlockBuilder>): this;
    build(writer: SourceWriter): void;
}
export declare class VariableBuilder implements AnyBuilder {
    private _name;
    private _type;
    private expressionBuilder?;
    private initializerMultiline;
    constructor(name: string, typeBuilder?: TypeBuilder);
    get name(): string;
    get type(): TypeBuilder;
    withName(name: string): this;
    withType(type: TypeBuilder | TypeAction): this;
    withInitializer(expressionBuilder: ExpressionBuilder | ExpressionAction, multiLine?: boolean): this;
    build(writer: SourceWriter): void;
}
export {};
//# sourceMappingURL=builder.decls.d.ts.map