import type { AnyBuilder, ToStringBuilder } from './common.js';
import type { SourceWriter } from './source-writer.js';
export declare const exprs: {
    initializerListOf: (elements: ToStringBuilder[], multiline?: boolean) => ExpressionBuilder;
    listOf: (elements: ToStringBuilder[], multiline?: boolean) => ExpressionBuilder;
    string: (value: string) => ExpressionBuilder;
    symbol: (name: string) => ExpressionBuilder;
};
export type ExpressionAction = (e: typeof exprs) => ExpressionBuilder;
export declare class ExpressionBuilder implements AnyBuilder, ToStringBuilder {
    private expression;
    constructor(expr?: ExpressionAction | string);
    addressOf(): ExpressionBuilder;
    build(writer: SourceWriter): void;
    toString(): string;
}
//# sourceMappingURL=builder.expr.d.ts.map