export const exprs = {
    initializerListOf: (elements, multiline = false) => new ExpressionBuilder(`{ ${elements.map((e) => e.toString()).join(multiline ? ',\n' : ', ')} }`),
    listOf: (elements, multiline = false) => new ExpressionBuilder(`${elements.map((e) => e.toString()).join(multiline ? ',\n' : ', ')}`),
    string: (value) => new ExpressionBuilder(`"${value}"`),
    symbol: (name) => new ExpressionBuilder(name),
};
export class ExpressionBuilder {
    constructor(expr = '') {
        if (typeof expr === 'function') {
            this.expression = expr(exprs).toString();
        }
        else {
            this.expression = expr;
        }
    }
    addressOf() {
        return new ExpressionBuilder(`&${this.expression}`);
    }
    build(writer) {
        writer.write(this.expression);
    }
    toString() {
        return this.expression;
    }
}
