import { SourceBlockBuilder } from './builder.block.js';
import type { SourceWriter } from './source-writer.js';
export declare class SourceFileBuilder extends SourceBlockBuilder {
    constructor(isHeader: boolean, writer?: SourceWriter);
    writeIncludeGuard(): this;
    /**
     * Adds an include preprocesor directive.
     *
     * @param path Path to include
     * @param local Whenever to use local include or a system include
     */
    private include;
    /**
     * Adds a local include preprocesor directive.
     *
     * @param path Path to include
     */
    includeLocal(path: string): this;
    /**
     * Adds a system include preprocesor directive.
     *
     * @param path Path to include
     */
    includeSystem(path: string): this;
}
//# sourceMappingURL=builder.file.d.ts.map