import type { AnyBuilder } from './common.js';
import type { SourceWriter } from './source-writer.js';
export declare const types: {
    readonly auto: TypeBuilder;
    readonly string: TypeBuilder;
    readonly stringVector: TypeBuilder;
    of(name: string): TypeBuilder;
    function(returnType: TypeBuilder, args: TypeBuilder[]): TypeBuilder;
    map(key: TypeBuilder, value: TypeBuilder): TypeBuilder;
};
export type TypeAction = (t: typeof types) => TypeBuilder;
export declare class TypeBuilder implements AnyBuilder {
    private type;
    constructor(type: string);
    build(writer: SourceWriter): void;
    toString(): string;
    asVector(): TypeBuilder;
    asSharedPtr(): TypeBuilder;
    asConst(): TypeBuilder;
    asRef(): TypeBuilder;
    asConstRef(): TypeBuilder;
    asPtr(): TypeBuilder;
    asConstPtr(): TypeBuilder;
}
//# sourceMappingURL=builder.types.d.ts.map