export class FunctionBuilder {
    constructor(name, returnTypeBuilder, parameters = []) {
        this.returnType = 'void';
        this.parameters = [];
        this.name = name;
        this.returnType = returnTypeBuilder?.toString() ?? 'void';
        this.parameters = parameters;
    }
    withReturnType(block) {
        this.returnType = block().toString();
        return this;
    }
    addParameter(block) {
        this.parameters.push(block());
        return this;
    }
    build(writer) {
        writer.write(`${this.returnType} ${this.name}`);
        writer.write('(');
        writer.writeCommaList(this.parameters, (param) => `${param.type} ${param.name}`);
        writer.write(')');
    }
}
