import { FunctionBuilder, VariableBuilder } from './builder.decls.js';
import { ExpressionBuilder } from './builder.expr.js';
import { SourceFileBuilder } from './builder.file.js';
import { TypeBuilder } from './builder.types.js';
export declare const cpp: {
    VariableBuilder: typeof VariableBuilder;
    FunctionBuilder: typeof FunctionBuilder;
    SourceFileBuilder: typeof SourceFileBuilder;
    exprs: {
        initializerListOf: (elements: import("./common.js").ToStringBuilder[], multiline?: boolean) => ExpressionBuilder;
        listOf: (elements: import("./common.js").ToStringBuilder[], multiline?: boolean) => ExpressionBuilder;
        string: (value: string) => ExpressionBuilder;
        symbol: (name: string) => ExpressionBuilder;
    };
    ExpressionBuilder: typeof ExpressionBuilder;
    types: {
        readonly auto: TypeBuilder;
        readonly string: TypeBuilder;
        readonly stringVector: TypeBuilder;
        of(name: string): TypeBuilder;
        function(returnType: TypeBuilder, args: TypeBuilder[]): TypeBuilder;
        map(key: TypeBuilder, value: TypeBuilder): TypeBuilder;
    };
    TypeBuilder: typeof TypeBuilder;
};
//# sourceMappingURL=index.d.ts.map