export const types = {
    get string() {
        return new TypeBuilder('std::string');
    },
    function(returnType, args) {
        const argsStr = args.map((a) => a.toString());
        const returnTypeStr = returnType.toString();
        return new TypeBuilder(`std::function<${returnTypeStr}(${argsStr.join(', ')})>`);
    }
};
export class TypeBuilder {
    constructor(type) {
        this.type = type;
    }
    build(writer) {
        writer.write(this.type);
    }
    toString() {
        return this.type;
    }
    asVector() {
        this.type = types.vector(this.type);
        return this;
    }
    asSharedPtr() {
        this.type = types.sharedPtr(this.type);
        return this;
    }
    asConst() {
        this.type = `const ${this.type}`;
        return this;
    }
    asRef() {
        this.type = `${this.type}&`;
        return this;
    }
    asConstRef() {
        this.type = `const ${this.type}&`;
        return this;
    }
    asPtr() {
        this.type = `${this.type}*`;
        return this;
    }
    asConstPtr() {
        this.type = `const ${this.type}*`;
        return this;
    }
}
