export const HEADER = `
//
// THIS FILE WAS GENERATED BY \`polygen\`
//
// DO NOT EDIT THIS FILE. ANY CHANGES WILL BE LOST.
//
`.trimStart();
/**
 * Mapping from WebAssembly table kind to the native C type, used by `wasm2c`.
 */
export const TABLE_KIND_TO_NATIVE_C_TYPE = {
    funcref: 'wasm_rt_funcref_table_t',
    externref: 'wasm_rt_externref_table_t',
};
/**
 * Mapping from WebAssembly table kind to the name of corresponding C++ class.
 *
 * The C++ Class is a Polygen wrapper to encapsulate common operations.
 */
export const TABLE_KIND_TO_CLASS_NAME = {
    funcref: 'FuncRefTable',
    externref: 'ExternRefTable',
};
// https://github.com/WebAssembly/wabt/blob/46648b09614b8c675e49a0fa5831e2dd8125b11d/src/c-writer.cc#L655
/**
 * When a function returns multiple values, the result is wrapped into a C struct.
 *
 * Each field of the struct is prefixed with a type-specific character.
 */
export const STRUCT_TYPE_PREFIX = {
    i32: 'i',
    i64: 'j',
    f32: 'f',
    f64: 'd',
    v128: 'o',
    funcref: 'r',
    externref: 'e',
    // exnref
};
export function toJSINumber(expr, type) {
    const cType = type.replace('i', 's'); // i32 -> s32
    return `jsi::Value { (double)std::bit_cast<${cType}>(${expr}) }`;
}
export function fromJSINumber(expr, type, w2cType) {
    const cType = type.replace('i', 's'); // i32 -> s32
    return `std::bit_cast<${w2cType}>(coerceToNumber<${cType}>(${expr}))`;
}
